# coding: utf-8

"""
    fluxoperator

    Python SDK for Flux-Operator  # noqa: E501

    The version of the OpenAPI document: v1alpha2
    Generated by: https://openapi-generator.tech
"""


try:
    from inspect import getfullargspec
except ImportError:
    from inspect import getargspec as getfullargspec
import pprint
import re  # noqa: F401
import six

from fluxoperator.configuration import Configuration


class FluxBroker(object):
    """NOTE: This class is auto generated by OpenAPI Generator.
    Ref: https://openapi-generator.tech

    Do not edit the class manually.
    """

    """
    Attributes:
      openapi_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    openapi_types = {
        'address': 'str',
        'name': 'str',
        'port': 'int',
        'size': 'int'
    }

    attribute_map = {
        'address': 'address',
        'name': 'name',
        'port': 'port',
        'size': 'size'
    }

    def __init__(self, address='', name='', port=8050, size=0, local_vars_configuration=None):  # noqa: E501
        """FluxBroker - a model defined in OpenAPI"""  # noqa: E501
        if local_vars_configuration is None:
            local_vars_configuration = Configuration.get_default_copy()
        self.local_vars_configuration = local_vars_configuration

        self._address = None
        self._name = None
        self._port = None
        self._size = None
        self.discriminator = None

        self.address = address
        self.name = name
        if port is not None:
            self.port = port
        self.size = size

    @property
    def address(self):
        """Gets the address of this FluxBroker.  # noqa: E501

        Lead broker address (ip or hostname)  # noqa: E501

        :return: The address of this FluxBroker.  # noqa: E501
        :rtype: str
        """
        return self._address

    @address.setter
    def address(self, address):
        """Sets the address of this FluxBroker.

        Lead broker address (ip or hostname)  # noqa: E501

        :param address: The address of this FluxBroker.  # noqa: E501
        :type address: str
        """
        if self.local_vars_configuration.client_side_validation and address is None:  # noqa: E501
            raise ValueError("Invalid value for `address`, must not be `None`")  # noqa: E501

        self._address = address

    @property
    def name(self):
        """Gets the name of this FluxBroker.  # noqa: E501

        We need the name of the lead job to assemble the hostnames  # noqa: E501

        :return: The name of this FluxBroker.  # noqa: E501
        :rtype: str
        """
        return self._name

    @name.setter
    def name(self, name):
        """Sets the name of this FluxBroker.

        We need the name of the lead job to assemble the hostnames  # noqa: E501

        :param name: The name of this FluxBroker.  # noqa: E501
        :type name: str
        """
        if self.local_vars_configuration.client_side_validation and name is None:  # noqa: E501
            raise ValueError("Invalid value for `name`, must not be `None`")  # noqa: E501

        self._name = name

    @property
    def port(self):
        """Gets the port of this FluxBroker.  # noqa: E501

        Lead broker port - should only be used for external cluster  # noqa: E501

        :return: The port of this FluxBroker.  # noqa: E501
        :rtype: int
        """
        return self._port

    @port.setter
    def port(self, port):
        """Sets the port of this FluxBroker.

        Lead broker port - should only be used for external cluster  # noqa: E501

        :param port: The port of this FluxBroker.  # noqa: E501
        :type port: int
        """

        self._port = port

    @property
    def size(self):
        """Gets the size of this FluxBroker.  # noqa: E501

        Lead broker size  # noqa: E501

        :return: The size of this FluxBroker.  # noqa: E501
        :rtype: int
        """
        return self._size

    @size.setter
    def size(self, size):
        """Sets the size of this FluxBroker.

        Lead broker size  # noqa: E501

        :param size: The size of this FluxBroker.  # noqa: E501
        :type size: int
        """
        if self.local_vars_configuration.client_side_validation and size is None:  # noqa: E501
            raise ValueError("Invalid value for `size`, must not be `None`")  # noqa: E501

        self._size = size

    def to_dict(self, serialize=False):
        """Returns the model properties as a dict"""
        result = {}

        def convert(x):
            if hasattr(x, "to_dict"):
                args = getfullargspec(x.to_dict).args
                if len(args) == 1:
                    return x.to_dict()
                else:
                    return x.to_dict(serialize)
            else:
                return x

        for attr, _ in six.iteritems(self.openapi_types):
            value = getattr(self, attr)
            attr = self.attribute_map.get(attr, attr) if serialize else attr
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: convert(x),
                    value
                ))
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], convert(item[1])),
                    value.items()
                ))
            else:
                result[attr] = convert(value)

        return result

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self.to_dict())

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, FluxBroker):
            return False

        return self.to_dict() == other.to_dict()

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        if not isinstance(other, FluxBroker):
            return True

        return self.to_dict() != other.to_dict()
